Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 407)
+++ palm/trunk/SOURCE/modules.f90	(revision 410)
@@ -8,4 +8,9 @@
 ! initial data assignments to some dvrp arrays changed due to error messages
 ! from gfortran compiler
+!
+! Branch revisions:
+! -----------------
+! Masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
+! mask_scale|_x|y|z, masks, netcdf_format_mask[_av], skip_time_domask
 !
 ! Former revisions:
@@ -281,4 +286,6 @@
     TYPE(file_status), DIMENSION(200) :: openfile = file_status(.FALSE.,.FALSE.)
 
+
+    INTEGER, PARAMETER :: mask_xyz_dimension = 100, max_masks = 20
 
     CHARACTER (LEN=1)    ::  cycle_mg = 'w', timestep_reason = ' '
@@ -322,8 +329,31 @@
     CHARACTER (LEN=11), DIMENSION(100) ::  data_output = ' ',    &
                                            data_output_user = ' ', doav = ' '
+    CHARACTER (LEN=10), DIMENSION(100) ::  &
+         data_output_mask_01      = ' ', data_output_mask_02      = ' ',  &
+         data_output_mask_03      = ' ', data_output_mask_04      = ' ',  &
+         data_output_mask_05      = ' ', data_output_mask_06      = ' ',  &
+         data_output_mask_07      = ' ', data_output_mask_08      = ' ',  &
+         data_output_mask_09      = ' ', data_output_mask_10      = ' ',  &
+         data_output_mask_11      = ' ', data_output_mask_12      = ' ',  &
+         data_output_mask_13      = ' ', data_output_mask_14      = ' ',  &
+         data_output_mask_15      = ' ', data_output_mask_16      = ' ',  &
+         data_output_mask_17      = ' ', data_output_mask_18      = ' ',  &
+         data_output_mask_19      = ' ', data_output_mask_20      = ' ',  &
+         data_output_mask_user_01 = ' ', data_output_mask_user_02 = ' ',  &
+         data_output_mask_user_03 = ' ', data_output_mask_user_04 = ' ',  &
+         data_output_mask_user_05 = ' ', data_output_mask_user_06 = ' ',  &
+         data_output_mask_user_07 = ' ', data_output_mask_user_08 = ' ',  &
+         data_output_mask_user_09 = ' ', data_output_mask_user_10 = ' ',  &
+         data_output_mask_user_11 = ' ', data_output_mask_user_12 = ' ',  &
+         data_output_mask_user_13 = ' ', data_output_mask_user_14 = ' ',  &
+         data_output_mask_user_15 = ' ', data_output_mask_user_16 = ' ',  &
+         data_output_mask_user_17 = ' ', data_output_mask_user_18 = ' ',  &
+         data_output_mask_user_19 = ' ', data_output_mask_user_20 = ' '
+
     CHARACTER (LEN=10), DIMENSION(300) ::  data_output_pr = ' '
     CHARACTER (LEN=10), DIMENSION(200) ::  data_output_pr_user = ' '
-    CHARACTER (LEN=20), DIMENSION(10)  ::  netcdf_precision = ' '
-
+    CHARACTER (LEN=20), DIMENSION(50)  ::  netcdf_precision = ' '
+
+    CHARACTER (LEN=10), DIMENSION(max_masks,0:1,100) ::  domask = ' '
     CHARACTER (LEN=10), DIMENSION(0:1,100) ::  do2d = ' ', do3d = ' '
 
@@ -341,7 +371,8 @@
                 inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
                 intermediate_timestep_count, intermediate_timestep_count_max, &
-                iran = -1234567, last_dt_change = 0, maximum_grid_level, &
+                iran = -1234567, last_dt_change = 0, masks = 0, &
+                maximum_grid_level, &
                 max_pr_user = 0, mgcycles = 0, mg_cycles = -1, &
-                mg_switch_to_pe0_level = 0, ngsrb = 2, nsor = 20, &
+                mg_switch_to_pe0_level = 0, mid, ngsrb = 2, nsor = 20, &
                 nsor_ini = 100, n_sor, normalizing_region = 0, &
                 nz_do1d, nz_do3d = -9999, outflow_damping_width = -1, &
@@ -354,5 +385,11 @@
                 do2d_xz_time_count(0:1), do2d_yz_time_count(0:1), &
                 do3d_no(0:1) = 0, do3d_time_count(0:1), &
+                domask_no(max_masks,0:1) = 0, domask_time_count(max_masks,0:1),&
                 lad_vertical_gradient_level_ind(10) = -9999, &
+                mask_size(max_masks,3) = -1, mask_size_l(max_masks,3) = -1, &
+                mask_start_l(max_masks,3) = -1, &
+                nc_format_mask(1:max_masks,0:1), &
+                netcdf_format_mask(1:max_masks) = 1, &
+                netcdf_format_mask_av(1:max_masks) = 1, &
                 pt_vertical_gradient_level_ind(10) = -9999, &
                 q_vertical_gradient_level_ind(10) = -9999, &
@@ -364,4 +401,8 @@
 
     INTEGER, DIMENSION(:), ALLOCATABLE ::  grid_level_count
+
+    INTEGER, DIMENSION(:,:), ALLOCATABLE   ::  mask_i, mask_j, mask_k
+    INTEGER, DIMENSION(:,:), ALLOCATABLE   ::  &
+                mask_i_global, mask_j_global, mask_k_global
 
     LOGICAL ::  adjust_mixing_length = .FALSE., avs_output = .FALSE., &
@@ -381,5 +422,6 @@
                 disturbance_created = .FALSE., &
                 first_call_advec_particles = .TRUE., &
-                force_print_header = .FALSE., galilei_transformation = .FALSE.,&
+                force_print_header = .FALSE., format_parallel_io = .FALSE., &
+		galilei_transformation = .FALSE.,&
                 humidity = .FALSE., humidity_remote = .FALSE., &
                 inflow_l = .FALSE., inflow_n = .FALSE., &
@@ -439,5 +481,7 @@
              km_damp_max = -1.0, lad_surface = 0.0,  &
              leaf_surface_concentration = 0.0, long_filter_factor = 0.0, &
-             maximum_cpu_time_allowed = 0.0, molecular_viscosity = 1.461E-5, &
+             mask_scale_x = 1.0, mask_scale_y = 1.0, mask_scale_z = 1.0, &
+             maximum_cpu_time_allowed = 0.0,  &
+             molecular_viscosity = 1.461E-5, &
              old_dt = 1.0E-10, omega = 7.29212E-5, omega_sor = 1.8, &
              overshoot_limit_e = 0.0, overshoot_limit_pt = 0.0, &
@@ -480,6 +524,7 @@
     REAL ::  do2d_xy_last_time(0:1) = -1.0, do2d_xz_last_time(0:1) = -1.0, &
              do2d_yz_last_time(0:1) = -1.0, dpdxy(1:2) = 0.0, &
-             lad_vertical_gradient(10) = 0.0, &
+             dt_domask(max_masks) = 9999999.9, lad_vertical_gradient(10) = 0.0,&
              lad_vertical_gradient_level(10) = -9999999.9, &
+             mask_scale(3), &
              pt_vertical_gradient(10) = 0.0, &
              pt_vertical_gradient_level(10) = -9999999.9, &
@@ -489,5 +534,7 @@
              s_vertical_gradient_level(10) = -1.0, &
              sa_vertical_gradient(10) = 0.0, &
-             sa_vertical_gradient_level(10) = -9999999.9, threshold(20) = 0.0, &
+             sa_vertical_gradient_level(10) = -9999999.9, &
+             skip_time_domask(max_masks) = 9999999.9, threshold(20) = 0.0, &
+             time_domask(max_masks) = 0.0, &
              tsc(10) = (/ 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /), &
              ug_vertical_gradient(10) = 0.0, &
@@ -502,4 +549,84 @@
     REAL, DIMENSION(:), ALLOCATABLE ::  dp_smooth_factor
 
+    REAL, DIMENSION(mask_xyz_dimension) ::  &
+       mask_01_x = -1.0, mask_02_x = -1.0, mask_03_x = -1.0, mask_04_x = -1.0, &
+       mask_05_x = -1.0, mask_06_x = -1.0, mask_07_x = -1.0, mask_08_x = -1.0, &
+       mask_09_x = -1.0, mask_10_x = -1.0, mask_11_x = -1.0, mask_12_x = -1.0, &
+       mask_13_x = -1.0, mask_14_x = -1.0, mask_15_x = -1.0, mask_16_x = -1.0, &
+       mask_17_x = -1.0, mask_18_x = -1.0, mask_19_x = -1.0, mask_20_x = -1.0, &
+       mask_01_y = -1.0, mask_02_y = -1.0, mask_03_y = -1.0, mask_04_y = -1.0, &
+       mask_05_y = -1.0, mask_06_y = -1.0, mask_07_y = -1.0, mask_08_y = -1.0, &
+       mask_09_y = -1.0, mask_10_y = -1.0, mask_11_y = -1.0, mask_12_y = -1.0, &
+       mask_13_y = -1.0, mask_14_y = -1.0, mask_15_y = -1.0, mask_16_y = -1.0, &
+       mask_17_y = -1.0, mask_18_y = -1.0, mask_19_y = -1.0, mask_20_y = -1.0, &
+       mask_01_z = -1.0, mask_02_z = -1.0, mask_03_z = -1.0, mask_04_z = -1.0, &
+       mask_05_z = -1.0, mask_06_z = -1.0, mask_07_z = -1.0, mask_08_z = -1.0, &
+       mask_09_z = -1.0, mask_10_z = -1.0, mask_11_z = -1.0, mask_12_z = -1.0, &
+       mask_13_z = -1.0, mask_14_z = -1.0, mask_15_z = -1.0, mask_16_z = -1.0, &
+       mask_17_z = -1.0, mask_18_z = -1.0, mask_19_z = -1.0, mask_20_z = -1.0
+    REAL, DIMENSION(3) ::  &
+       mask_01_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_02_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_03_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_04_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_05_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_06_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_07_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_08_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_09_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_10_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_11_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_12_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_13_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_14_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_15_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_16_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_17_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_18_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_19_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_20_x_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_01_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_02_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_03_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_04_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_05_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_06_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_07_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_08_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_09_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_10_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_11_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_12_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_13_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_14_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_15_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_16_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_17_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_18_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_19_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_20_y_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_01_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_02_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_03_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_04_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_05_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_06_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_07_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_08_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_09_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_10_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_11_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_12_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_13_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_14_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_15_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_16_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_17_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_18_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_19_z_loop = (/ -1.0, -1.0, 0.0 /), &
+       mask_20_z_loop = (/ -1.0, -1.0, 0.0 /)
+!
+!--    internal mask arrays ("mask,dimension,selection")
+       REAL, DIMENSION(:,:,:), ALLOCATABLE ::  mask, mask_loop
 
     SAVE
@@ -832,4 +959,5 @@
 !------------------------------------------------------------------------------!
 
+    USE control_parameters
 #if defined( __netcdf )
     USE netcdf
@@ -934,6 +1062,7 @@
                 id_var_zw_xy, id_var_zw_xz, id_var_zw_yz, id_var_zw_3d
 
-    INTEGER, DIMENSION(10)  ::  id_var_dospx, id_var_dospy, nc_precision 
+    INTEGER, DIMENSION(10)  ::  id_var_dospx, id_var_dospy
     INTEGER, DIMENSION(20)  ::  id_var_prt
+    INTEGER, DIMENSION(50)  ::  nc_precision
     INTEGER, DIMENSION(dopr_norm_num) ::  id_var_norm_dopr
 
@@ -944,5 +1073,19 @@
     INTEGER, DIMENSION(dots_max,0:9)   ::  id_var_dots
 
+!
+!-- masked output
+    CHARACTER (LEN=7), DIMENSION(max_masks,0:1,100) ::  domask_unit
+
     LOGICAL ::  output_for_t0 = .FALSE.
+
+    INTEGER, DIMENSION(1:max_masks,0:1) ::  id_dim_time_mask, id_dim_x_mask, &
+                id_dim_xu_mask, id_dim_y_mask, id_dim_yv_mask, id_dim_zu_mask, &
+                id_dim_zw_mask, &
+                id_set_mask, &
+                id_var_time_mask, id_var_x_mask, id_var_xu_mask, &
+                id_var_y_mask, id_var_yv_mask, id_var_zu_mask, id_var_zw_mask, &
+                id_var_zusi_mask, id_var_zwwi_mask
+
+    INTEGER, DIMENSION(1:max_masks,0:1,100)         ::  id_var_domask
 
     SAVE
